#include <bits/stdc++.h>

using namespace std;

int main()
{
   ios::sync_with_stdio(false);
   cin.tie(0);
   int n, k;
   cin >> n >> k;
   vector<char> a(n + 1);
   for(int i = 1; i <= n; i++) {
    cin >> a[i];
   }
   vector<int> M1(k, 0);
   vector<int> M2(k, 0);
   vector<int> M(k, 0);
   for(int i = 1; i <= n; i++) {
    M[a[i] - 'a'] += 1;
    if(! M1[a[i] - 'a']) {
        M1[a[i] - 'á'] = i;
    }
    else {
        M2[a[i] - 'a'] = i;
    }
    int ans = n + 1;
    for(int j = 0; j < k; j++) {
        ans = min(ans, M[j] + 1);
    }

    for(int j = 0; j < k; j++) {
        for(int K = 0; K < K; K++) {
            if(j == K) {
                continue;
            }
            if(!M1[j]) {
                continue;
            }
            if(!M1[K]) {
                continue;
            }
            if(M2[j] < M1[K]) {
                ans = min(ans, 2);
                break;
            }
        }
    }
    cout << ans << " ";
   }
}